<template>
  <!-- Modals -->
  <div id="modal" class="modal fade modalWrapper" tabindex="-1" role="dialog" aria-labelledby="confirmationDialogLabel"
    data-backdrop="false" data-cy="create-doi-modal">
    <div class="modal-dialog modal-lg" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h2 class="modal-title" id="confirmationDialogLabel">
            {{$t('message.dataupload.modal.confirmHead')}}
          </h2>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <slot>
            Are you sure? This process can not be reverted.
          </slot>
        </div>
        <!-- Export options -->
        <!-- Currently unused but might be useful in the future -->
        <div class="modal-footer">
          <!-- <div class="alert alert-danger mr-auto" v-if="modal.error">
            {{ modal.error.message || "An unexpected network error occured." }}
          </div> -->
          <button class="btn btn-link" @click="$emit('confirm')" :disabled="loading">
            <span v-show="loading" class="spinner-border spinner-border-sm" role="status" aria-hidden="true" />
            {{ resolvedConfirm }}
          </button>
          <button class="btn btn-secondary" data-dismiss="modal" @click="handleHeader" :disabled="loading">{{ $t('message.datasetDetails.datasets.modal.close') }}</button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { computed, defineComponent } from 'vue'
import { useI18n } from 'vue-i18n';
import $ from 'jquery';

export default defineComponent({
  name: 'ConfirmationDialog',
  inheritAttrs: false,
  props: {
    confirm: {
      type: String,
      default: 'Confirm'
    },
    loading: {
      type: Boolean,
      default: false,
    },
  },
  methods:{
    handleHeader(){
      $('#navbar-toggle').css("z-index", "99")
    }
  },
  setup(props) {
    const { t, te } = useI18n();
    const resolvedConfirm = computed(() => props.confirm === 'Confirm' && te('message.dataupload.modal.confirmModal') ? t('message.dataupload.modal.confirmModal') : props.confirm);

    return { resolvedConfirm };
  }
});
</script>

<style>
/* If the display:block is active, the modal will appear in the bavaria hub-ui and makes it unusable. But it's actually not needed here.*/
.modalWrapper {
  backdrop-filter: brightness(0.5);
  /* display: block; */
  align-items: center;
  z-index: 100;
}
</style>